﻿using Microsoft.Extensions.Logging;
using NetworkResurrector.Agent.Application.Services.Abstractions;
using System;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace NetworkResurrector.Agent.Application.Services
{
    internal class ShutdownService : IShutdownService
    {
        private readonly ILogger<ShutdownService> _logger;

        public ShutdownService(ILogger<ShutdownService> logger)
        {
            _logger=logger;
        }

        public void Run()
        {
            if (RuntimeInformation.IsOSPlatform(OSPlatform.Windows))
            {
                ShutdownWindows();
            }
            else if (RuntimeInformation.IsOSPlatform(OSPlatform.Linux))
            {
                // Do something
            }
            else throw new Exception("ShutdownService: Cannot shutdown host. Unknown operating system.");
        }

        private void ShutdownWindows()
        {
            var psi = new ProcessStartInfo("shutdown", "/s /t 0")
            {
                CreateNoWindow = true,
                UseShellExecute = false
            };

            Process.Start(psi);
        }
    }
}
